/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 30/05/22.
//

#ifndef FGGL_GFX_OGL4_DEBUG_HPP
#define FGGL_GFX_OGL4_DEBUG_HPP

#include "fggl/debug/draw.hpp"

namespace fggl::gfx::ogl4 {

	class DebugRenderer : public dd::RenderInterface {
		public:
			explicit DebugRenderer(std::shared_ptr<ogl::Shader> shader);
			~DebugRenderer() override = default;
			void drawLineList(const dd::DrawVertex *lines, int count, bool depthEnabled) override;

			math::mat4 mvpMatrix;
		private:
			std::shared_ptr<ogl::Shader> m_lineShader;
			ogl::Location m_lineShaderMVP;
			ogl::VertexArray m_lineVao;
			ogl::ArrayBuffer m_lineVbo;
	};

}

#endif //FGGL_GFX_OGL4_DEBUG_HPP
